#-*- mode: python; mode: fold -*-
# $Id: Students.py 472 2006-09-02 14:51:14Z henrik $
from Globals import InitializeClass
from AccessControl import ClassSecurityInfo
from AccessControl.SecurityManagement import newSecurityManager
from zExceptions import BadRequest
from Products.CMFCore.utils import UniqueObject, getToolByName
from Products.CMFCore.permissions import View
from Products.CMFCore.permissions import ModifyPortalContent
from Products.CPSCore.CPSBase import CPSBase_adder, CPSBaseFolder
#from Products.CPSCore.CPSBase import CPSBaseDocument as BaseDocument
from Products.CPSDocument.CPSDocument import CPSDocument

class ScratchCardBatchesFolder(CPSDocument): ###(
    """
    WAeUP Student container for the various student data
    """
    meta_type = 'ScratchCardBatchesFolder'
    portal_type = meta_type
    security = ClassSecurityInfo()

    security.declareProtected(View,"Title")
    def Title(self):
        """compose title"""
        return "Pin Batches"


InitializeClass(ScratchCardBatchesFolder)

def addScratchCardBatchesFolder(container, id, REQUEST=None, **kw):
    """Add a Students personal data."""
    ob = ScratchCardBatchesFolder(id, **kw)
    return CPSBase_adder(container, ob, REQUEST=REQUEST)

###)

from Products.WAeUP_SRP.WAeUPTables import PinTable

class ScratchCardBatch(CPSDocument): ###(
    """
    WAeUP Student container for the various student data
    """
    meta_type = 'ScratchCardBatch'
    portal_type = meta_type
    security = ClassSecurityInfo()

    def __init__(self,id,**kw):
        CPSDocument.__init__(self,id,**kw)
        self.table = PinTable()
        
    security.declareProtected(View,"Title")
    def Title(self):
        """compose title"""
        doc = self.getContent()
        return "Pin Batch %s BatchNo %d" % (doc.prefix, doc.batch_no)

    security.declareProtected(ModifyPortalContent,"makePins")
    def makePins(self):
        """generate Pins"""
        batch = self.getContent()
        nr = batch.no_of_pins
        import random
        r = random
        b_no = batch.batch_no
        for i in range(nr):
            pin = "%d%d" % (b_no,r.randint(999999999,1000000000))
            import pdp;pdb.set_trace()
            while len(res) > 0: 
                pin = "%d%d" % (b_no,r.randint(9999,1000000000))
                res = self.table.searchResults(uid=pin)
            self.table.addRecord(pin=pin,serial=i,student="")
            print i,pin


InitializeClass(ScratchCardBatch)

def addScratchCardBatch(container, id, REQUEST=None, **kw):
    """Add a Students personal data."""
    ob = ScratchCardBatch(id, **kw)
    return CPSBase_adder(container, ob, REQUEST=REQUEST)

###)
